/* Company		: Trenz Electronics
 * Author		: Oleksandr Kiyenko
 * Created on	: 07.12.2012
 *
 */
#include "uart.h"

void uart_init(void){
	XUartNs550_SetBaud(UART_BASEADDR, UART_CLOCK_HZ, UART_BAUDRATE);
	XUartNs550_SetLineControlReg(UART_BASEADDR, XUN_LCR_8_DATA_BITS);
	XUartNs550_WriteReg(UART_BASEADDR, XUN_FCR_OFFSET, XUN_FIFO_ENABLE);
}

u8 uart_getc(void){
	return XUartNs550_RecvByte(UART_BASEADDR);
}

void print(char* str){
	u32 i = 0;
	while(str[i])
		XUartNs550_SendByte(UART_BASEADDR, str[i++]);
}

void print_char(char c){
	XUartNs550_SendByte(UART_BASEADDR, c);
}

void print_u8(u8 c){
	u8 t;
	t = c >> 4;
	if(t < 10)
		XUartNs550_SendByte(UART_BASEADDR, ('0' + t));
	else
		XUartNs550_SendByte(UART_BASEADDR, ('A' + t - 10));
	t = c & 0x0F;
	if(t < 10)
		XUartNs550_SendByte(UART_BASEADDR, ('0' + t));
	else
		XUartNs550_SendByte(UART_BASEADDR, ('A' + t - 10));
}

void print_u32(u32 w){
	print_u8(w >> 24);
	print_u8((w >> 16) & 0xFF);
	print_u8((w >> 8) & 0xFF);
	print_u8(w & 0xFF);
}
